Index: trunk/src/VBox/GuestHost/SharedClipboard/ClipboardFiles.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/ClipboardFiles.cpp	(revision 78389)
+++ trunk/src/VBox/GuestHost/SharedClipboard/ClipboardFiles.cpp	(revision 78390)
@@ -1,9 +1,9 @@
 /* $Id$ */
 /** @file
- * DnD - Directory handling.
+ * Shared Clipboard - Directory handling.
  */
 
 /*
- * Copyright (C) 2014-2019 Oracle Corporation
+ * Copyright (C) 2019 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -20,6 +20,6 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#define LOG_GROUP LOG_GROUP_GUEST_DND
-#include <VBox/GuestHost/DragAndDrop.h>
+#define LOG_GROUP LOG_GROUP_SHARED_CLIPBOARD
+#include <VBox/GuestHost/SharedClipboard-uri.h>
 
 #include <iprt/assert.h>
@@ -33,9 +33,10 @@
 #include <VBox/log.h>
 
-DnDDroppedFiles::DnDDroppedFiles(void)
+SharedClipboardDroppedFiles::SharedClipboardDroppedFiles(void)
     : m_fOpen(0)
     , m_hDir(NULL) { }
 
-DnDDroppedFiles::DnDDroppedFiles(const char *pszPath, DNDURIDROPPEDFILEFLAGS fFlags /* = DNDURIDROPPEDFILE_FLAGS_NONE */)
+SharedClipboardDroppedFiles::SharedClipboardDroppedFiles(const char *pszPath,
+                                                         SHAREDCLIPBOARDURIDROPPEDFILEFLAGS fFlags /* = SHAREDCLIPBOARDURIDROPPEDFILE_FLAGS_NONE */)
     : m_fOpen(0)
     , m_hDir(NULL)
@@ -44,5 +45,5 @@
 }
 
-DnDDroppedFiles::~DnDDroppedFiles(void)
+SharedClipboardDroppedFiles::~SharedClipboardDroppedFiles(void)
 {
     /* Only make sure to not leak any handles and stuff, don't delete any
@@ -51,5 +52,5 @@
 }
 
-int DnDDroppedFiles::AddFile(const char *pszFile)
+int SharedClipboardDroppedFiles::AddFile(const char *pszFile)
 {
     AssertPtrReturn(pszFile, VERR_INVALID_POINTER);
@@ -60,5 +61,5 @@
 }
 
-int DnDDroppedFiles::AddDir(const char *pszDir)
+int SharedClipboardDroppedFiles::AddDir(const char *pszDir)
 {
     AssertPtrReturn(pszDir, VERR_INVALID_POINTER);
@@ -69,5 +70,5 @@
 }
 
-int DnDDroppedFiles::closeInternal(void)
+int SharedClipboardDroppedFiles::closeInternal(void)
 {
     int rc;
@@ -85,20 +86,20 @@
 }
 
-int DnDDroppedFiles::Close(void)
+int SharedClipboardDroppedFiles::Close(void)
 {
     return closeInternal();
 }
 
-const char *DnDDroppedFiles::GetDirAbs(void) const
+const char *SharedClipboardDroppedFiles::GetDirAbs(void) const
 {
     return this->m_strPathAbs.c_str();
 }
 
-bool DnDDroppedFiles::IsOpen(void) const
+bool SharedClipboardDroppedFiles::IsOpen(void) const
 {
     return (this->m_hDir != NULL);
 }
 
-int DnDDroppedFiles::OpenEx(const char *pszPath, DNDURIDROPPEDFILEFLAGS fFlags /* = DNDURIDROPPEDFILE_FLAGS_NONE */)
+int SharedClipboardDroppedFiles::OpenEx(const char *pszPath, SHAREDCLIPBOARDURIDROPPEDFILEFLAGS fFlags /* = SHAREDCLIPBOARDURIDROPPEDFILE_FLAGS_NONE */)
 {
     AssertPtrReturn(pszPath, VERR_INVALID_POINTER);
@@ -117,5 +118,5 @@
 
         /* Append our base drop directory. */
-        rc = RTPathAppend(pszDropDir, sizeof(pszDropDir), "VirtualBox Dropped Files"); /** @todo Make this tag configurable? */
+        rc = RTPathAppend(pszDropDir, sizeof(pszDropDir), "VirtualBox Shared Clipboard Files"); /** @todo Make this tag configurable? */
         if (RT_FAILURE(rc))
             break;
@@ -139,5 +140,5 @@
         }
 
-        rc = DnDPathSanitizeFilename(pszTime, sizeof(pszTime));
+        rc = SharedClipboardPathSanitizeFilename(pszTime, sizeof(pszTime));
         if (RT_FAILURE(rc))
             break;
@@ -167,5 +168,5 @@
 }
 
-int DnDDroppedFiles::OpenTemp(DNDURIDROPPEDFILEFLAGS fFlags /* = DNDURIDROPPEDFILE_FLAGS_NONE */)
+int SharedClipboardDroppedFiles::OpenTemp(SHAREDCLIBOARDURIDROPPEDFILEFLAGS fFlags /* = SHAREDCLIPBOARDURIDROPPEDFILE_FLAGS_NONE */)
 {
     AssertReturn(fFlags == 0, VERR_INVALID_PARAMETER); /* Flags not supported yet. */
@@ -184,5 +185,5 @@
 }
 
-int DnDDroppedFiles::Reset(bool fRemoveDropDir)
+int SharedClipboardDroppedFiles::Reset(bool fRemoveDropDir)
 {
     int rc = closeInternal();
@@ -204,5 +205,5 @@
 }
 
-int DnDDroppedFiles::Reopen(void)
+int SharedClipboardDroppedFiles::Reopen(void)
 {
     if (this->m_strPathAbs.isEmpty())
@@ -212,5 +213,5 @@
 }
 
-int DnDDroppedFiles::Rollback(void)
+int SharedClipboardDroppedFiles::Rollback(void)
 {
     if (this->m_strPathAbs.isEmpty())
Index: trunk/src/VBox/GuestHost/SharedClipboard/ClipboardMIME.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/ClipboardMIME.cpp	(revision 78389)
+++ trunk/src/VBox/GuestHost/SharedClipboard/ClipboardMIME.cpp	(revision 78390)
@@ -1,9 +1,9 @@
 /* $Id$ */
 /** @file
- * DnD - Path list class.
+ * Shared Clipboard - Path list class.
  */
 
 /*
- * Copyright (C) 2014-2019 Oracle Corporation
+ * Copyright (C) 2019 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -20,11 +20,11 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#define LOG_GROUP LOG_GROUP_GUEST_DND
-#include <VBox/GuestHost/DragAndDrop.h>
+#define LOG_GROUP LOG_GROUP_SHARED_CLIPBOARD
+#include <VBox/GuestHost/SharedClipboard-uri.h>
 
 #include <iprt/string.h>
 
 
-bool DnDMIMEHasFileURLs(const char *pcszFormat, size_t cchFormatMax)
+bool SharedClipboardMIMEHasFileURLs(const char *pcszFormat, size_t cchFormatMax)
 {
     /** @todo "text/uri" also an official variant? */
@@ -33,5 +33,5 @@
 }
 
-bool DnDMIMENeedsDropDir(const char *pcszFormat, size_t cchFormatMax)
+bool SharedClipboardMIMENeedsDropDir(const char *pcszFormat, size_t cchFormatMax)
 {
     bool fNeedsDropDir = false;
Index: trunk/src/VBox/GuestHost/SharedClipboard/ClipboardPath.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/ClipboardPath.cpp	(revision 78389)
+++ trunk/src/VBox/GuestHost/SharedClipboard/ClipboardPath.cpp	(revision 78390)
@@ -1,9 +1,9 @@
 /* $Id$ */
 /** @file
- * DnD - Path handling.
+ * Shared Clipboard - Path handling.
  */
 
 /*
- * Copyright (C) 2014-2019 Oracle Corporation
+ * Copyright (C) 2019 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -20,6 +20,6 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#define LOG_GROUP LOG_GROUP_GUEST_DND
-#include <VBox/GuestHost/DragAndDrop.h>
+#define LOG_GROUP LOG_GROUP_SHARED_CLIPBOARD
+#include <VBox/GuestHost/SharedClipboard-uri.h>
 
 #include <iprt/err.h>
@@ -36,5 +36,5 @@
  * @param   cbPath              Size (in bytes) of path to sanitize.
  */
-int DnDPathSanitizeFilename(char *pszPath, size_t cbPath)
+int SharedClipboardPathSanitizeFilename(char *pszPath, size_t cbPath)
 {
     int rc = VINF_SUCCESS;
@@ -64,5 +64,5 @@
 }
 
-int DnDPathSanitize(char *pszPath, size_t cbPath)
+int SharedClipboardPathSanitize(char *pszPath, size_t cbPath)
 {
     /** @todo */
Index: trunk/src/VBox/GuestHost/SharedClipboard/ClipboardURIList.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/ClipboardURIList.cpp	(revision 78389)
+++ trunk/src/VBox/GuestHost/SharedClipboard/ClipboardURIList.cpp	(revision 78390)
@@ -1,9 +1,9 @@
 /* $Id$ */
 /** @file
- * DnD - URI list class.
+ * Shared Clipboard - URI list class.
  */
 
 /*
- * Copyright (C) 2014-2019 Oracle Corporation
+ * Copyright (C) 2019 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -20,6 +20,6 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#define LOG_GROUP LOG_GROUP_GUEST_DND
-#include <VBox/GuestHost/DragAndDrop.h>
+#define LOG_GROUP LOG_GROUP_SHARED_CLIPBOARD
+#include <VBox/GuestHost/SharedClipboard-uri.h>
 
 #include <iprt/dir.h>
@@ -35,5 +35,5 @@
 
 
-DnDURIList::DnDURIList(void)
+SharedClipboardURIList::SharedClipboardURIList(void)
     : m_cTotal(0)
     , m_cbTotal(0)
@@ -41,10 +41,10 @@
 }
 
-DnDURIList::~DnDURIList(void)
+SharedClipboardURIList::~SharedClipboardURIList(void)
 {
     Clear();
 }
 
-int DnDURIList::addEntry(const char *pcszSource, const char *pcszTarget, DNDURILISTFLAGS fFlags)
+int SharedClipboardURIList::addEntry(const char *pcszSource, const char *pcszTarget, SHAREDCLIPBOARDURILISTFLAGS fFlags)
 {
     AssertPtrReturn(pcszSource, VERR_INVALID_POINTER);
@@ -62,9 +62,9 @@
                          pcszSource, pcszTarget, (uint64_t)objInfo.cbObject, objInfo.Attr.fMode));
 
-            DnDURIObject *pObjFile = new DnDURIObject(DnDURIObject::Type_File, pcszSource, pcszTarget);
+            SharedClipboardURIObject *pObjFile = new SharedClipboardURIObject(SharedClipboardURIObject::Type_File, pcszSource, pcszTarget);
             if (pObjFile)
             {
                 /** @todo Add a standard fOpen mode for this list. */
-                rc = pObjFile->Open(DnDURIObject::View_Source, RTFILE_O_OPEN | RTFILE_O_READ | RTFILE_O_DENY_WRITE);
+                rc = pObjFile->Open(SharedClipboardURIObject::View_Source, RTFILE_O_OPEN | RTFILE_O_READ | RTFILE_O_DENY_WRITE);
                 if (RT_SUCCESS(rc))
                 {
@@ -74,5 +74,5 @@
                     m_cbTotal += pObjFile->GetSize();
 
-                    if (!(fFlags & DNDURILIST_FLAGS_KEEP_OPEN)) /* Shall we keep the file open while being added to this list? */
+                    if (!(fFlags & SHAREDCLIPBOARDURILIST_FLAGS_KEEP_OPEN)) /* Shall we keep the file open while being added to this list? */
                         pObjFile->Close();
                 }
@@ -87,10 +87,10 @@
             LogFlowFunc(("Directory '%s' -> '%s' (file mode 0x%x)\n", pcszSource, pcszTarget, objInfo.Attr.fMode));
 
-            DnDURIObject *pObjDir = new DnDURIObject(DnDURIObject::Type_Directory, pcszSource, pcszTarget);
+            SharedClipboardURIObject *pObjDir = new SharedClipboardURIObject(SharedClipboardURIObject::Type_Directory, pcszSource, pcszTarget);
             if (pObjDir)
             {
                 m_lstTree.append(pObjDir);
 
-                /** @todo Add DNDURILIST_FLAGS_KEEP_OPEN handling? */
+                /** @todo Add SHAREDCLIPBOARDURILIST_FLAGS_KEEP_OPEN handling? */
                 m_cTotal++;
             }
@@ -107,7 +107,7 @@
 }
 
-int DnDURIList::appendPathRecursive(const char *pcszSrcPath,
+int SharedClipboardURIList::appendPathRecursive(const char *pcszSrcPath,
                                     const char *pcszDstPath, const char *pcszDstBase, size_t cchDstBase,
-                                    DNDURILISTFLAGS fFlags)
+                                    SHAREDCLIPBOARDURILISTFLAGS fFlags)
 {
     AssertPtrReturn(pcszSrcPath, VERR_INVALID_POINTER);
@@ -192,5 +192,5 @@
                             case RTFS_TYPE_SYMLINK:
                             {
-                                if (fFlags & DNDURILIST_FLAGS_RESOLVE_SYMLINKS)
+                                if (fFlags & SHAREDCLIPBOARDURILIST_FLAGS_RESOLVE_SYMLINKS)
                                 {
                                     char *pszSrc = RTPathRealDup(pcszDstBase);
@@ -239,5 +239,5 @@
         else if (RTFS_IS_SYMLINK(objInfo.Attr.fMode))
         {
-            if (fFlags & DNDURILIST_FLAGS_RESOLVE_SYMLINKS)
+            if (fFlags & SHAREDCLIPBOARDURILIST_FLAGS_RESOLVE_SYMLINKS)
             {
                 char *pszSrc = RTPathRealDup(pcszSrcPath);
@@ -275,5 +275,5 @@
 }
 
-int DnDURIList::AppendNativePath(const char *pszPath, DNDURILISTFLAGS fFlags)
+int SharedClipboardURIList::AppendNativePath(const char *pszPath, SHAREDCLIPBOARDURILISTFLAGS fFlags)
 {
     AssertPtrReturn(pszPath, VERR_INVALID_POINTER);
@@ -303,6 +303,6 @@
 }
 
-int DnDURIList::AppendNativePathsFromList(const char *pszNativePaths, size_t cbNativePaths,
-                                          DNDURILISTFLAGS fFlags)
+int SharedClipboardURIList::AppendNativePathsFromList(const char *pszNativePaths, size_t cbNativePaths,
+                                          SHAREDCLIPBOARDURILISTFLAGS fFlags)
 {
     AssertPtrReturn(pszNativePaths, VERR_INVALID_POINTER);
@@ -314,6 +314,6 @@
 }
 
-int DnDURIList::AppendNativePathsFromList(const RTCList<RTCString> &lstNativePaths,
-                                          DNDURILISTFLAGS fFlags)
+int SharedClipboardURIList::AppendNativePathsFromList(const RTCList<RTCString> &lstNativePaths,
+                                          SHAREDCLIPBOARDURILISTFLAGS fFlags)
 {
     int rc = VINF_SUCCESS;
@@ -331,8 +331,8 @@
 }
 
-int DnDURIList::AppendURIPath(const char *pszURI, DNDURILISTFLAGS fFlags)
+int SharedClipboardURIList::AppendURIPath(const char *pszURI, SHAREDCLIPBOARDURILISTFLAGS fFlags)
 {
     AssertPtrReturn(pszURI, VERR_INVALID_POINTER);
-    AssertReturn(!(fFlags & ~DNDURILIST_FLAGS_VALID_MASK), VERR_INVALID_FLAGS);
+    AssertReturn(!(fFlags & ~SHAREDCLIPBOARDURILIST_FLAGS_VALID_MASK), VERR_INVALID_FLAGS);
     /** @todo Check for string termination?  */
 
@@ -380,5 +380,5 @@
             {
                 Assert(pszFileName >= pszSrcPath);
-                size_t cchDstBase = (fFlags & DNDURILIST_FLAGS_ABSOLUTE_PATHS)
+                size_t cchDstBase = (fFlags & SHAREDCLIPBOARDURILIST_FLAGS_ABSOLUTE_PATHS)
                                   ? 0 /* Use start of path as root. */
                                   : pszFileName - pszSrcPath;
@@ -404,6 +404,6 @@
 }
 
-int DnDURIList::AppendURIPathsFromList(const char *pszURIPaths, size_t cbURIPaths,
-                                       DNDURILISTFLAGS fFlags)
+int SharedClipboardURIList::AppendURIPathsFromList(const char *pszURIPaths, size_t cbURIPaths,
+                                       SHAREDCLIPBOARDURILISTFLAGS fFlags)
 {
     AssertPtrReturn(pszURIPaths, VERR_INVALID_POINTER);
@@ -415,6 +415,6 @@
 }
 
-int DnDURIList::AppendURIPathsFromList(const RTCList<RTCString> &lstURI,
-                                       DNDURILISTFLAGS fFlags)
+int SharedClipboardURIList::AppendURIPathsFromList(const RTCList<RTCString> &lstURI,
+                                       SHAREDCLIPBOARDURILISTFLAGS fFlags)
 {
     int rc = VINF_SUCCESS;
@@ -433,5 +433,5 @@
 }
 
-void DnDURIList::Clear(void)
+void SharedClipboardURIList::Clear(void)
 {
     m_lstRoot.clear();
@@ -439,5 +439,5 @@
     for (size_t i = 0; i < m_lstTree.size(); i++)
     {
-        DnDURIObject *pCurObj = m_lstTree.at(i);
+        SharedClipboardURIObject *pCurObj = m_lstTree.at(i);
         AssertPtr(pCurObj);
         RTMemFree(pCurObj);
@@ -449,10 +449,10 @@
 }
 
-void DnDURIList::RemoveFirst(void)
+void SharedClipboardURIList::RemoveFirst(void)
 {
     if (m_lstTree.isEmpty())
         return;
 
-    DnDURIObject *pCurObj = m_lstTree.first();
+    SharedClipboardURIObject *pCurObj = m_lstTree.first();
     AssertPtr(pCurObj);
 
@@ -467,5 +467,5 @@
 }
 
-int DnDURIList::SetFromURIData(const void *pvData, size_t cbData, DNDURILISTFLAGS fFlags)
+int SharedClipboardURIList::SetFromURIData(const void *pvData, size_t cbData, SHAREDCLIPBOARDURILISTFLAGS fFlags)
 {
     Assert(fFlags == 0); RT_NOREF1(fFlags);
@@ -494,5 +494,5 @@
         if (pszFilePath)
         {
-            rc = DnDPathSanitize(pszFilePath, strlen(pszFilePath));
+            rc = SharedClipboardPathSanitize(pszFilePath, strlen(pszFilePath));
             if (RT_SUCCESS(rc))
             {
@@ -513,5 +513,5 @@
 }
 
-RTCString DnDURIList::GetRootEntries(const RTCString &strPathBase /* = "" */,
+RTCString SharedClipboardURIList::GetRootEntries(const RTCString &strPathBase /* = "" */,
                                    const RTCString &strSeparator /* = "\r\n" */) const
 {
Index: trunk/src/VBox/GuestHost/SharedClipboard/ClipboardURIObject.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/ClipboardURIObject.cpp	(revision 78389)
+++ trunk/src/VBox/GuestHost/SharedClipboard/ClipboardURIObject.cpp	(revision 78390)
@@ -1,9 +1,9 @@
 /* $Id$ */
 /** @file
- * DnD - URI object class. For handling creation/reading/writing to files and directories on host or guest side.
+ * Shared Clipboard - URI object class. For handling creation/reading/writing to files and directories on host or guest side.
  */
 
 /*
- * Copyright (C) 2014-2019 Oracle Corporation
+ * Copyright (C) 2019 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -20,6 +20,6 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#define LOG_GROUP LOG_GROUP_GUEST_DND
-#include <VBox/GuestHost/DragAndDrop.h>
+#define LOG_GROUP LOG_GROUP_SHARED_CLIPBOARD
+#include <VBox/GuestHost/SharedClipboard-uri.h>
 
 #include <iprt/dir.h>
@@ -33,5 +33,5 @@
 
 
-DnDURIObject::DnDURIObject(void)
+SharedClipboardURIObject::SharedClipboardURIObject(void)
     : m_enmType(Type_Unknown)
     , m_enmView(View_Unknown)
@@ -40,7 +40,7 @@
 }
 
-DnDURIObject::DnDURIObject(Type enmType,
-                           const RTCString &strSrcPathAbs /* = 0 */,
-                           const RTCString &strDstPathAbs /* = 0 */)
+SharedClipboardURIObject::SharedClipboardURIObject(Type enmType,
+                                                   const RTCString &strSrcPathAbs /* = 0 */,
+                                                   const RTCString &strDstPathAbs /* = 0 */)
     : m_enmType(enmType)
     , m_enmView(View_Unknown)
@@ -69,5 +69,5 @@
 }
 
-DnDURIObject::~DnDURIObject(void)
+SharedClipboardURIObject::~SharedClipboardURIObject(void)
 {
     closeInternal();
@@ -78,5 +78,5 @@
  *
  */
-void DnDURIObject::closeInternal(void)
+void SharedClipboardURIObject::closeInternal(void)
 {
     LogFlowThisFuncEnter();
@@ -109,5 +109,5 @@
  * This also closes the internal handles associated with the object (to files / ...).
  */
-void DnDURIObject::Close(void)
+void SharedClipboardURIObject::Close(void)
 {
     closeInternal();
@@ -119,5 +119,5 @@
  * @return  File / directory mode.
  */
-RTFMODE DnDURIObject::GetMode(void) const
+RTFMODE SharedClipboardURIObject::GetMode(void) const
 {
     switch (m_enmType)
@@ -140,9 +140,9 @@
  * Returns the bytes already processed (read / written).
  *
- * Note: Only applies if the object is of type DnDURIObject::Type_File.
+ * Note: Only applies if the object is of type SharedClipboardURIObject::Type_File.
  *
  * @return  Bytes already processed (read / written).
  */
-uint64_t DnDURIObject::GetProcessed(void) const
+uint64_t SharedClipboardURIObject::GetProcessed(void) const
 {
     if (m_enmType == Type_File)
@@ -155,9 +155,9 @@
  * Returns the file's logical size (in bytes).
  *
- * Note: Only applies if the object is of type DnDURIObject::Type_File.
+ * Note: Only applies if the object is of type SharedClipboardURIObject::Type_File.
  *
  * @return  The file's logical size (in bytes).
  */
-uint64_t DnDURIObject::GetSize(void) const
+uint64_t SharedClipboardURIObject::GetSize(void) const
 {
     if (m_enmType == Type_File)
@@ -173,5 +173,5 @@
  * @return  True if complete, False if not.
  */
-bool DnDURIObject::IsComplete(void) const
+bool SharedClipboardURIObject::IsComplete(void) const
 {
     bool fComplete;
@@ -199,5 +199,5 @@
  * Returns whether the object is in an open state or not.
  */
-bool DnDURIObject::IsOpen(void) const
+bool SharedClipboardURIObject::IsOpen(void) const
 {
     switch (m_enmType)
@@ -219,9 +219,9 @@
  * @param   fMode               File mode to use.
  */
-int DnDURIObject::Open(View enmView, uint64_t fOpen /* = 0 */, RTFMODE fMode /* = 0 */)
+int SharedClipboardURIObject::Open(View enmView, uint64_t fOpen /* = 0 */, RTFMODE fMode /* = 0 */)
 {
     return OpenEx(  enmView == View_Source
                   ? m_strSrcPathAbs : m_strTgtPathAbs
-                  , enmView, fOpen, fMode, DNDURIOBJECT_FLAGS_NONE);
+                  , enmView, fOpen, fMode, SHAREDCLIPBOARDURIOBJECT_FLAGS_NONE);
 }
 
@@ -234,10 +234,10 @@
  * @param   fOpen               Open mode to use; only valid for file objects.
  * @param   fMode               File mode to use; only valid for file objects.
- * @param   fFlags              Additional DnD URI object flags.
- */
-int DnDURIObject::OpenEx(const RTCString &strPathAbs, View enmView,
-                         uint64_t fOpen /* = 0 */, RTFMODE fMode /* = 0 */, DNDURIOBJECTFLAGS fFlags /* = DNDURIOBJECT_FLAGS_NONE */)
-{
-    AssertReturn(!(fFlags & ~DNDURIOBJECT_FLAGS_VALID_MASK), VERR_INVALID_FLAGS);
+ * @param   fFlags              Additional Shared Clipboard URI object flags.
+ */
+int SharedClipboardURIObject::OpenEx(const RTCString &strPathAbs, View enmView,
+                                     uint64_t fOpen /* = 0 */, RTFMODE fMode /* = 0 */, SHAREDCLIPBOARDURIOBJECTFLAGS fFlags /* = SHAREDCLIPBOARDURIOBJECT_FLAGS_NONE */)
+{
+    AssertReturn(!(fFlags & ~SHAREDCLIPBOARDURIOBJECT_FLAGS_VALID_MASK), VERR_INVALID_FLAGS);
     RT_NOREF1(fFlags);
 
@@ -328,5 +328,5 @@
  * @param   enmView             View to use for querying information. Currently ignored.
  */
-int DnDURIObject::queryInfoInternal(View enmView)
+int SharedClipboardURIObject::queryInfoInternal(View enmView)
 {
     RT_NOREF(enmView);
@@ -360,5 +360,5 @@
  * @param   enmView             View to use for querying information.
  */
-int DnDURIObject::QueryInfo(View enmView)
+int SharedClipboardURIObject::QueryInfo(View enmView)
 {
     return queryInfoInternal(enmView);
@@ -374,8 +374,8 @@
  * @param   strBaseNew          New base path to rebase to.
  *
- ** @todo Put this into an own class like DnDURIPath : public RTCString?
+ ** @todo Put this into an own class like SharedClipboardURIPath : public RTCString?
  */
 /* static */
-int DnDURIObject::RebaseURIPath(RTCString &strPathAbs,
+int SharedClipboardURIObject::RebaseURIPath(RTCString &strPathAbs,
                                 const RTCString &strBaseOld /* = "" */,
                                 const RTCString &strBaseNew /* = "" */)
@@ -439,5 +439,5 @@
  * @param   pcbRead             Pointer where to store how many bytes were read. Optional.
  */
-int DnDURIObject::Read(void *pvBuf, size_t cbBuf, uint32_t *pcbRead)
+int SharedClipboardURIObject::Read(void *pvBuf, size_t cbBuf, uint32_t *pcbRead)
 {
     AssertPtrReturn(pvBuf, VERR_INVALID_POINTER);
@@ -495,5 +495,5 @@
  * Resets the object's state and closes all related handles.
  */
-void DnDURIObject::Reset(void)
+void SharedClipboardURIObject::Reset(void)
 {
     LogFlowThisFuncEnter();
@@ -512,10 +512,10 @@
  * Sets the bytes to process by the object.
  *
- * Note: Only applies if the object is of type DnDURIObject::Type_File.
+ * Note: Only applies if the object is of type SharedClipboardURIObject::Type_File.
  *
  * @return  IPRT return code.
  * @param   cbSize          Size (in bytes) to process.
  */
-int DnDURIObject::SetSize(uint64_t cbSize)
+int SharedClipboardURIObject::SetSize(uint64_t cbSize)
 {
     AssertReturn(m_enmType == Type_File, VERR_INVALID_PARAMETER);
@@ -535,5 +535,5 @@
  * @param   pcbWritten          Pointer where to store how many bytes were written. Optional.
  */
-int DnDURIObject::Write(const void *pvBuf, size_t cbBuf, uint32_t *pcbWritten)
+int SharedClipboardURIObject::Write(const void *pvBuf, size_t cbBuf, uint32_t *pcbWritten)
 {
     AssertPtrReturn(pvBuf, VERR_INVALID_POINTER);