Index: trunk/src/VBox/Additions/WINNT/Installer/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Makefile.kmk	(revision 78389)
+++ trunk/src/VBox/Additions/WINNT/Installer/Makefile.kmk	(revision 78408)
@@ -102,9 +102,4 @@
 ifdef VBOX_WITH_CROGL
 DRIVER_FILES += \
-	$(PATH_STAGE_BIN)/additions/VBoxOGLcrutil.dll \
-	$(PATH_STAGE_BIN)/additions/VBoxOGLerrorspu.dll \
-	$(PATH_STAGE_BIN)/additions/VBoxOGLpackspu.dll \
-	$(PATH_STAGE_BIN)/additions/VBoxOGLpassthroughspu.dll \
-	$(PATH_STAGE_BIN)/additions/VBoxOGLfeedbackspu.dll \
 	$(PATH_STAGE_BIN)/additions/VBoxOGL.dll \
 	$(PATH_STAGE_BIN)/additions/wined3d.dll \
@@ -115,14 +110,8 @@
 	# running 32-bit OpenGL apps on that.
 	DRIVER_FILES += \
-		$(VBOX_PATH_ADDITIONS.win.x86)/VBoxOGLcrutil.dll \
-		$(VBOX_PATH_ADDITIONS.win.x86)/VBoxOGLerrorspu.dll \
-		$(VBOX_PATH_ADDITIONS.win.x86)/VBoxOGLpackspu.dll \
-		$(VBOX_PATH_ADDITIONS.win.x86)/VBoxOGLpassthroughspu.dll \
-		$(VBOX_PATH_ADDITIONS.win.x86)/VBoxOGLfeedbackspu.dll \
 		$(VBOX_PATH_ADDITIONS.win.x86)/VBoxOGL.dll \
 		$(VBOX_PATH_ADDITIONS.win.x86)/wined3d.dll \
 		$(VBOX_PATH_ADDITIONS.win.x86)/VBoxD3D9.dll \
 		$(VBOX_PATH_ADDITIONS.win.x86)/VBoxD3D8.dll
-
  endif
 endif
@@ -162,14 +151,8 @@
 	$(PATH_STAGE_BIN)/additions/wined3dwddm-x86.dll \
 	$(PATH_STAGE_BIN)/additions/VBoxD3D9wddm-x86.dll \
-	$(PATH_STAGE_BIN)/additions/VBoxOGL-x86.dll \
-	$(PATH_STAGE_BIN)/additions/VBoxOGLcrutil-x86.dll \
-	$(PATH_STAGE_BIN)/additions/VBoxOGLerrorspu-x86.dll \
-	$(PATH_STAGE_BIN)/additions/VBoxOGLfeedbackspu-x86.dll \
-	$(PATH_STAGE_BIN)/additions/VBoxOGLpackspu-x86.dll \
-	$(PATH_STAGE_BIN)/additions/VBoxOGLpassthroughspu-x86.dll
+	$(PATH_STAGE_BIN)/additions/VBoxOGL-x86.dll
   endif
  endif
 endif
-
 VB_WIN_ADD_NSIS_ENV := \
 	-E 'PATH_OUT=$(subst /,\,$(PATH_OUT))' \
Index: trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsCommon.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsCommon.nsh	(revision 78389)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsCommon.nsh	(revision 78408)
@@ -64,9 +64,4 @@
 !if $%VBOX_WITH_CROGL% == "1"
   ; crOpenGL
-  FILE "$%PATH_OUT%\bin\additions\VBoxOGLcrutil.dll"
-  FILE "$%PATH_OUT%\bin\additions\VBoxOGLerrorspu.dll"
-  FILE "$%PATH_OUT%\bin\additions\VBoxOGLpackspu.dll"
-  FILE "$%PATH_OUT%\bin\additions\VBoxOGLpassthroughspu.dll"
-  FILE "$%PATH_OUT%\bin\additions\VBoxOGLfeedbackspu.dll"
   FILE "$%PATH_OUT%\bin\additions\VBoxOGL.dll"
 
@@ -83,9 +78,4 @@
     FILE "$%VBOX_PATH_ADDITIONS_WIN_X86%\d3d8.dll"
     FILE "$%VBOX_PATH_ADDITIONS_WIN_X86%\d3d9.dll"
-    FILE "$%VBOX_PATH_ADDITIONS_WIN_X86%\VBoxOGLcrutil.dll"
-    FILE "$%VBOX_PATH_ADDITIONS_WIN_X86%\VBoxOGLerrorspu.dll"
-    FILE "$%VBOX_PATH_ADDITIONS_WIN_X86%\VBoxOGLpackspu.dll"
-    FILE "$%VBOX_PATH_ADDITIONS_WIN_X86%\VBoxOGLpassthroughspu.dll"
-    FILE "$%VBOX_PATH_ADDITIONS_WIN_X86%\VBoxOGLfeedbackspu.dll"
     FILE "$%VBOX_PATH_ADDITIONS_WIN_X86%\VBoxOGL.dll"
     FILE "$%VBOX_PATH_ADDITIONS_WIN_X86%\VBoxD3D8.dll"
@@ -113,9 +103,4 @@
 
   !if $%VBOX_WITH_CROGL% == "1"
-    FILE "$%PATH_OUT%\bin\additions\VBoxOGLcrutil.dll"
-    FILE "$%PATH_OUT%\bin\additions\VBoxOGLerrorspu.dll"
-    FILE "$%PATH_OUT%\bin\additions\VBoxOGLpackspu.dll"
-    FILE "$%PATH_OUT%\bin\additions\VBoxOGLpassthroughspu.dll"
-    FILE "$%PATH_OUT%\bin\additions\VBoxOGLfeedbackspu.dll"
     FILE "$%PATH_OUT%\bin\additions\VBoxOGL.dll"
 
@@ -134,9 +119,4 @@
 
     !if $%VBOX_WITH_CROGL% == "1"
-      FILE "$%PATH_OUT%\bin\additions\VBoxOGLcrutil-x86.dll"
-      FILE "$%PATH_OUT%\bin\additions\VBoxOGLerrorspu-x86.dll"
-      FILE "$%PATH_OUT%\bin\additions\VBoxOGLpackspu-x86.dll"
-      FILE "$%PATH_OUT%\bin\additions\VBoxOGLpassthroughspu-x86.dll"
-      FILE "$%PATH_OUT%\bin\additions\VBoxOGLfeedbackspu-x86.dll"
       FILE "$%PATH_OUT%\bin\additions\VBoxOGL-x86.dll"
 
Index: trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsW2KXP.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsW2KXP.nsh	(revision 78389)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsW2KXP.nsh	(revision 78408)
@@ -248,9 +248,4 @@
 
     !if $%VBOX_WITH_CROGL% == "1"
-      FILE "$%PATH_OUT%\bin\additions\VBoxOGLcrutil.dll"
-      FILE "$%PATH_OUT%\bin\additions\VBoxOGLerrorspu.dll"
-      FILE "$%PATH_OUT%\bin\additions\VBoxOGLpackspu.dll"
-      FILE "$%PATH_OUT%\bin\additions\VBoxOGLpassthroughspu.dll"
-      FILE "$%PATH_OUT%\bin\additions\VBoxOGLfeedbackspu.dll"
       FILE "$%PATH_OUT%\bin\additions\VBoxOGL.dll"
 
@@ -269,9 +264,4 @@
 
       !if $%VBOX_WITH_CROGL% == "1"
-        FILE "$%PATH_OUT%\bin\additions\VBoxOGLcrutil-x86.dll"
-        FILE "$%PATH_OUT%\bin\additions\VBoxOGLerrorspu-x86.dll"
-        FILE "$%PATH_OUT%\bin\additions\VBoxOGLpackspu-x86.dll"
-        FILE "$%PATH_OUT%\bin\additions\VBoxOGLpassthroughspu-x86.dll"
-        FILE "$%PATH_OUT%\bin\additions\VBoxOGLfeedbackspu-x86.dll"
         FILE "$%PATH_OUT%\bin\additions\VBoxOGL-x86.dll"
 
@@ -292,9 +282,4 @@
   StrCpy $0 "$TEMP\VBoxGuestAdditions\VBoxOGL"
   CreateDirectory "$0"
-  !insertmacro InstallLib DLL NOTSHARED REBOOT_PROTECTED "$%PATH_OUT%\bin\additions\VBoxOGLcrutil.dll"         "$g_strSystemDir\VBoxOGLcrutil.dll"         "$0"
-  !insertmacro InstallLib DLL NOTSHARED REBOOT_PROTECTED "$%PATH_OUT%\bin\additions\VBoxOGLerrorspu.dll"       "$g_strSystemDir\VBoxOGLerrorspu.dll"       "$0"
-  !insertmacro InstallLib DLL NOTSHARED REBOOT_PROTECTED "$%PATH_OUT%\bin\additions\VBoxOGLpackspu.dll"        "$g_strSystemDir\VBoxOGLpackspu.dll"        "$0"
-  !insertmacro InstallLib DLL NOTSHARED REBOOT_PROTECTED "$%PATH_OUT%\bin\additions\VBoxOGLpassthroughspu.dll" "$g_strSystemDir\VBoxOGLpassthroughspu.dll" "$0"
-  !insertmacro InstallLib DLL NOTSHARED REBOOT_PROTECTED "$%PATH_OUT%\bin\additions\VBoxOGLfeedbackspu.dll"    "$g_strSystemDir\VBoxOGLfeedbackspu.dll"    "$0"
   !insertmacro InstallLib DLL NOTSHARED REBOOT_PROTECTED "$%PATH_OUT%\bin\additions\VBoxOGL.dll"               "$g_strSystemDir\VBoxOGL.dll"               "$0"
   !if $%BUILD_TARGET_ARCH% == "amd64"
@@ -309,9 +294,4 @@
     ; path after calling EnableX64FSRedirection
     ${EnableX64FSRedirection}
-    !insertmacro InstallLib DLL NOTSHARED REBOOT_PROTECTED "$%VBOX_PATH_ADDITIONS_WIN_X86%\VBoxOGLcrutil.dll"         "$SYSDIR\VBoxOGLcrutil.dll"         "$0"
-    !insertmacro InstallLib DLL NOTSHARED REBOOT_PROTECTED "$%VBOX_PATH_ADDITIONS_WIN_X86%\VBoxOGLerrorspu.dll"       "$SYSDIR\VBoxOGLerrorspu.dll"       "$0"
-    !insertmacro InstallLib DLL NOTSHARED REBOOT_PROTECTED "$%VBOX_PATH_ADDITIONS_WIN_X86%\VBoxOGLpackspu.dll"        "$SYSDIR\VBoxOGLpackspu.dll"        "$0"
-    !insertmacro InstallLib DLL NOTSHARED REBOOT_PROTECTED "$%VBOX_PATH_ADDITIONS_WIN_X86%\VBoxOGLpassthroughspu.dll" "$SYSDIR\VBoxOGLpassthroughspu.dll" "$0"
-    !insertmacro InstallLib DLL NOTSHARED REBOOT_PROTECTED "$%VBOX_PATH_ADDITIONS_WIN_X86%\VBoxOGLfeedbackspu.dll"    "$SYSDIR\VBoxOGLfeedbackspu.dll"    "$0"
     !insertmacro InstallLib DLL NOTSHARED REBOOT_PROTECTED "$%VBOX_PATH_ADDITIONS_WIN_X86%\VBoxOGL.dll"               "$SYSDIR\VBoxOGL.dll"               "$0"
     ${DisableX64FSRedirection}
@@ -540,4 +520,5 @@
   !endif
 
+    ; Obsolete files begin (they were merged into VBoxOGL.dll)
     Delete /REBOOTOK "$INSTDIR\VBoxOGLcrutil.dll"
     Delete /REBOOTOK "$INSTDIR\VBoxOGLarrayspu.dll"
@@ -546,4 +527,6 @@
     Delete /REBOOTOK "$INSTDIR\VBoxOGLpassthroughspu.dll"
     Delete /REBOOTOK "$INSTDIR\VBoxOGLfeedbackspu.dll"
+    ; Obsolete files end
+
     Delete /REBOOTOK "$INSTDIR\VBoxOGL.dll"
 
@@ -562,4 +545,5 @@
     !endif
 
+      ; Obsolete files begin (they were merged into VBoxOGL-x86.dll)
       Delete /REBOOTOK "$INSTDIR\VBoxOGLcrutil-x86.dll"
       Delete /REBOOTOK "$INSTDIR\VBoxOGLarrayspu-x86.dll"
@@ -568,4 +552,6 @@
       Delete /REBOOTOK "$INSTDIR\VBoxOGLpassthroughspu-x86.dll"
       Delete /REBOOTOK "$INSTDIR\VBoxOGLfeedbackspu-x86.dll"
+      ; Obsolete files end
+
       Delete /REBOOTOK "$INSTDIR\VBoxOGL-x86.dll"
 
@@ -661,4 +647,5 @@
   ${EndIf}
 
+  ; Obsolete files begin (they were merged into VBoxOGL.dll)
   Delete /REBOOTOK "$g_strSystemDir\VBoxOGLcrutil.dll"
   Delete /REBOOTOK "$g_strSystemDir\VBoxOGLarrayspu.dll"
@@ -667,4 +654,6 @@
   Delete /REBOOTOK "$g_strSystemDir\VBoxOGLpassthroughspu.dll"
   Delete /REBOOTOK "$g_strSystemDir\VBoxOGLfeedbackspu.dll"
+  ; Obsolete files end
+
   Delete /REBOOTOK "$g_strSystemDir\VBoxOGL.dll"
 
@@ -698,4 +687,5 @@
   !if $%BUILD_TARGET_ARCH% == "amd64"
     ; Only 64-bit installer: Also remove 32-bit DLLs on 64-bit target arch in Wow64 node
+    ; Obsolete files begin (they were merged into VBoxOGL-x86.dll)
     Delete /REBOOTOK "$g_strSysWow64\VBoxOGLcrutil-x86.dll"
     Delete /REBOOTOK "$g_strSysWow64\VBoxOGLarrayspu-x86.dll"
@@ -704,4 +694,6 @@
     Delete /REBOOTOK "$g_strSysWow64\VBoxOGLpassthroughspu-x86.dll"
     Delete /REBOOTOK "$g_strSysWow64\VBoxOGLfeedbackspu-x86.dll"
+    ; Obsolete files end
+
     Delete /REBOOTOK "$g_strSysWow64\VBoxOGL-x86.dll"
 