Index: /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp
===================================================================
--- /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp	(revision 78438)
+++ /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp	(revision 78439)
@@ -202,5 +202,5 @@
     if (pClient->fMsgQuit)
     {
-        LogRelFlow(("vboxSvcClipboardReturnMsg: Quit\n"));
+        LogFlowFunc(("vboxSvcClipboardReturnMsg: Quit\n"));
         VBoxHGCMParmUInt32Set(&paParms[0], VBOX_SHARED_CLIPBOARD_HOST_MSG_QUIT);
         VBoxHGCMParmUInt32Set(&paParms[1], 0);
@@ -211,5 +211,5 @@
         uint32_t fFormat = 0;
 
-        LogRelFlow(("vboxSvcClipboardReturnMsg: ReadData %02X\n", pClient->u32RequestedFormat));
+        LogFlowFunc(("vboxSvcClipboardReturnMsg: ReadData %02X\n", pClient->u32RequestedFormat));
         if (pClient->u32RequestedFormat & VBOX_SHARED_CLIPBOARD_FMT_UNICODETEXT)
             fFormat = VBOX_SHARED_CLIPBOARD_FMT_UNICODETEXT;
@@ -228,5 +228,5 @@
     else if (pClient->fMsgFormats)
     {
-        LogRelFlow(("vboxSvcClipboardReturnMsg: Formats %02X\n", pClient->u32AvailableFormats));
+        LogFlowFunc(("vboxSvcClipboardReturnMsg: Formats %02X\n", pClient->u32AvailableFormats));
         VBoxHGCMParmUInt32Set(&paParms[0], VBOX_SHARED_CLIPBOARD_HOST_MSG_REPORT_FORMATS);
         VBoxHGCMParmUInt32Set(&paParms[1], pClient->u32AvailableFormats);
@@ -236,5 +236,5 @@
     {
         /* No pending messages. */
-        LogRelFlow(("vboxSvcClipboardReturnMsg: no message\n"));
+        LogFlowFunc(("vboxSvcClipboardReturnMsg: no message\n"));
         return false;
     }
@@ -254,5 +254,5 @@
             case VBOX_SHARED_CLIPBOARD_HOST_MSG_QUIT:
             {
-                LogRelFlow(("vboxSvcClipboardReportMsg: Quit\n"));
+                LogFlowFunc(("Quit\n"));
                 pClient->fMsgQuit = true;
             } break;
@@ -266,5 +266,5 @@
                 }
 
-                LogRelFlow(("vboxSvcClipboardReportMsg: ReadData %02X\n", u32Formats));
+                LogFlowFunc(("ReadData %02X\n", u32Formats));
                 pClient->u32RequestedFormat = u32Formats;
                 pClient->fMsgReadData = true;
@@ -279,5 +279,5 @@
                 }
 
-                LogRelFlow(("vboxSvcClipboardReportMsg: Formats %02X\n", u32Formats));
+                LogFlowFunc(("Formats %02X\n", u32Formats));
                 pClient->u32AvailableFormats = u32Formats;
                 pClient->fMsgFormats = true;
@@ -286,5 +286,5 @@
             {
                 /* Invalid message. */
-                LogRelFlow(("vboxSvcClipboardReportMsg: invalid message %d\n", u32Msg));
+                LogFlowFunc(("invalid message %d\n", u32Msg));
             } break;
         }
@@ -308,5 +308,5 @@
             if (fMessageReturned)
             {
-                LogRelFlow(("vboxSvcClipboardReportMsg: CallComplete\n"));
+                LogFlowFunc(("CallComplete\n"));
                 g_pHelpers->pfnCallComplete(callHandle, VINF_SUCCESS);
             }
@@ -356,5 +356,5 @@
     VBOXCLIPBOARDCLIENTDATA *pClient = (VBOXCLIPBOARDCLIENTDATA *)pvClient;
 
-    LogRel2(("svcDisconnect: u32ClientID = %d\n", u32ClientID));
+    LogFunc(("u32ClientID = %d\n", u32ClientID));
 
     vboxSvcClipboardReportMsg(pClient, VBOX_SHARED_CLIPBOARD_HOST_MSG_QUIT, 0);
@@ -400,6 +400,5 @@
     }
 
-    LogRel2(("vboxClipboardConnect: rc = %Rrc\n", rc));
-
+    LogFlowFuncLeaveRC(rc);
     return rc;
 }
@@ -417,5 +416,5 @@
     int rc = VINF_SUCCESS;
 
-    LogRel2(("svcCall: u32ClientID = %d, fn = %d, cParms = %d, pparms = %d\n",
+    LogFunc(("u32ClientID = %d, fn = %d, cParms = %d, pparms = %d\n",
              u32ClientID, u32Function, cParms, paParms));
 
@@ -430,5 +429,5 @@
     {
         /** @todo parameters other than 32 bit */
-        LogRel2(("    pparms[%d]: type %d value %d\n", i, paParms[i].type, paParms[i].u.uint32));
+        LogFunc(("    pparms[%d]: type %d value %d\n", i, paParms[i].type, paParms[i].u.uint32));
     }
 #endif
@@ -439,5 +438,5 @@
         {
             /* The quest requests a host message. */
-            LogRel2(("svcCall: VBOX_SHARED_CLIPBOARD_FN_GET_HOST_MSG\n"));
+            LogFunc(("VBOX_SHARED_CLIPBOARD_FN_GET_HOST_MSG\n"));
 
             if (cParms != VBOX_SHARED_CLIPBOARD_CPARMS_GET_HOST_MSG)
@@ -472,5 +471,5 @@
                         pClient->async.paParms    = paParms;
 
-                        LogRel2(("svcCall: async.\n"));
+                        LogFunc(("async.\n"));
                     }
 
@@ -487,5 +486,5 @@
         {
             /* The guest reports that some formats are available. */
-            LogRel2(("svcCall: VBOX_SHARED_CLIPBOARD_FN_FORMATS\n"));
+            LogFunc(("VBOX_SHARED_CLIPBOARD_FN_FORMATS\n"));
 
             if (cParms != VBOX_SHARED_CLIPBOARD_CPARMS_FORMATS)
@@ -532,5 +531,5 @@
         {
             /* The guest wants to read data in the given format. */
-            LogRel2(("svcCall: VBOX_SHARED_CLIPBOARD_FN_READ_DATA\n"));
+            LogFunc(("VBOX_SHARED_CLIPBOARD_FN_READ_DATA\n"));
 
             if (cParms != VBOX_SHARED_CLIPBOARD_CPARMS_READ_DATA)
@@ -578,5 +577,5 @@
                             g_fReadingData = true;
                             rc = g_pfnExtension (g_pvExtension, VBOX_CLIPBOARD_EXT_FN_DATA_READ, &parms, sizeof (parms));
-                            LogRelFlow(("DATA: g_fDelayedAnnouncement = %d, g_u32DelayedFormats = 0x%x\n", g_fDelayedAnnouncement, g_u32DelayedFormats));
+                            LogFlowFunc(("DATA: g_fDelayedAnnouncement = %d, g_u32DelayedFormats = 0x%x\n", g_fDelayedAnnouncement, g_u32DelayedFormats));
                             if (g_fDelayedAnnouncement)
                             {
@@ -628,5 +627,5 @@
         {
             /* The guest writes the requested data. */
-            LogRel2(("svcCall: VBOX_SHARED_CLIPBOARD_FN_WRITE_DATA\n"));
+            LogFunc(("VBOX_SHARED_CLIPBOARD_FN_WRITE_DATA\n"));
 
             if (cParms != VBOX_SHARED_CLIPBOARD_CPARMS_WRITE_DATA)
@@ -686,5 +685,5 @@
     }
 
-    LogRelFlow(("svcCall: rc = %Rrc\n", rc));
+    LogFlowFunc(("rc = %Rrc\n", rc));
 
     if (!fAsynchronousProcessing)
@@ -727,5 +726,5 @@
     int rc = VINF_SUCCESS;
 
-    LogRel2(("svcHostCall: fn = %d, cParms = %d, pparms = %d\n",
+    LogFunc(("svcHostCall: fn = %d, cParms = %d, pparms = %d\n",
              u32Function, cParms, paParms));
 
@@ -734,5 +733,5 @@
         case VBOX_SHARED_CLIPBOARD_HOST_FN_SET_MODE:
         {
-            LogRel2(("svcCall: VBOX_SHARED_CLIPBOARD_HOST_FN_SET_MODE\n"));
+            LogFunc(("VBOX_SHARED_CLIPBOARD_HOST_FN_SET_MODE\n"));
 
             if (cParms != 1)
@@ -765,5 +764,5 @@
             rc = VBoxHGCMParmUInt32Get (&paParms[0], &u32Headless);
             if (RT_SUCCESS(rc))
-                LogRelFlow(("svcCall: VBOX_SHARED_CLIPBOARD_HOST_FN_SET_HEADLESS, u32Headless=%u\n",
+                LogFlowFunc(("VBOX_SHARED_CLIPBOARD_HOST_FN_SET_HEADLESS, u32Headless=%u\n",
                             (unsigned) u32Headless));
             g_fHeadless = RT_BOOL(u32Headless);
@@ -774,5 +773,5 @@
     }
 
-    LogRelFlow(("svcHostCall: rc = %Rrc\n", rc));
+    LogFlowFunc(("svcHostCall: rc = %Rrc\n", rc));
     return rc;
 }
@@ -802,5 +801,5 @@
      * Pending requests, if any, will be completed in svcDisconnect.
      */
-    LogRel2(("svcSaveState: u32ClientID = %d\n", u32ClientID));
+    LogFunc(("u32ClientID = %d\n", u32ClientID));
 
     VBOXCLIPBOARDCLIENTDATA *pClient = (VBOXCLIPBOARDCLIENTDATA *)pvClient;
@@ -866,5 +865,6 @@
 #ifndef UNIT_TEST
     RT_NOREF(uVersion);
-    LogRel2(("svcLoadState: u32ClientID = %d\n", u32ClientID));
+
+    LogFunc(("u32ClientID = %d\n", u32ClientID));
 
     VBOXCLIPBOARDCLIENTDATA *pClient = (VBOXCLIPBOARDCLIENTDATA *)pvClient;
@@ -921,5 +921,5 @@
     else
     {
-        LogRel(("Client data size mismatch: got %#x\n", lenOrVer));
+        LogFunc(("Client data size mismatch: got %#x\n", lenOrVer));
         return VERR_SSM_DATA_UNIT_FORMAT_CHANGED;
     }
@@ -928,5 +928,5 @@
     if (pClient->u32ClientID != u32ClientIDOld)
     {
-        LogRel(("Client ID mismatch: expected %d, got %d\n", u32ClientIDOld, pClient->u32ClientID));
+        LogFunc(("Client ID mismatch: expected %d, got %d\n", u32ClientIDOld, pClient->u32ClientID));
         pClient->u32ClientID = u32ClientIDOld;
         return VERR_SSM_DATA_UNIT_FORMAT_CHANGED;
@@ -951,5 +951,5 @@
             case VBOX_CLIPBOARD_EXT_FN_FORMAT_ANNOUNCE:
             {
-                LogRelFlow(("ANNOUNCE: g_fReadingData = %d\n", g_fReadingData));
+                LogFlowFunc(("ANNOUNCE: g_fReadingData = %d\n", g_fReadingData));
                 if (g_fReadingData)
                 {
@@ -978,5 +978,5 @@
 static DECLCALLBACK(int) svcRegisterExtension(void *, PFNHGCMSVCEXT pfnExtension, void *pvExtension)
 {
-    LogRelFlowFunc(("pfnExtension = %p\n", pfnExtension));
+    LogFlowFunc(("pfnExtension=%p\n", pfnExtension));
 
     VBOXCLIPBOARDEXTPARMS parms;
@@ -1011,5 +1011,5 @@
     int rc = VINF_SUCCESS;
 
-    LogRelFlowFunc(("ptable = %p\n", ptable));
+    LogFlowFunc(("ptable=%p\n", ptable));
 
     if (!ptable)
@@ -1019,5 +1019,5 @@
     else
     {
-        LogRel2(("VBoxHGCMSvcLoad: ptable->cbSize = %d, ptable->u32Version = 0x%08X\n", ptable->cbSize, ptable->u32Version));
+        LogFunc(("ptable->cbSize = %d, ptable->u32Version = 0x%08X\n", ptable->cbSize, ptable->u32Version));
 
         if (   ptable->cbSize     != sizeof (VBOXHGCMSVCFNTABLE)