Index: /trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendCOM.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendCOM.cpp	(revision 78520)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendCOM.cpp	(revision 78521)
@@ -572,13 +572,13 @@
     switch (bus)
     {
-        case KStorageBus_IDE:    return QApplication::translate("VBoxGlobal", "IDE", "StorageBus");
-        case KStorageBus_SATA:   return QApplication::translate("VBoxGlobal", "SATA", "StorageBus");
-        case KStorageBus_SCSI:   return QApplication::translate("VBoxGlobal", "SCSI", "StorageBus");
-        case KStorageBus_Floppy: return QApplication::translate("VBoxGlobal", "Floppy", "StorageBus");
-        case KStorageBus_SAS:    return QApplication::translate("VBoxGlobal", "SAS", "StorageBus");
-        case KStorageBus_USB:    return QApplication::translate("VBoxGlobal", "USB", "StorageBus");
-        case KStorageBus_PCIe:   return QApplication::translate("VBoxGlobal", "PCIe", "StorageBus");
+        case KStorageBus_IDE:        return QApplication::translate("VBoxGlobal", "IDE", "StorageBus");
+        case KStorageBus_SATA:       return QApplication::translate("VBoxGlobal", "SATA", "StorageBus");
+        case KStorageBus_SCSI:       return QApplication::translate("VBoxGlobal", "SCSI", "StorageBus");
+        case KStorageBus_Floppy:     return QApplication::translate("VBoxGlobal", "Floppy", "StorageBus");
+        case KStorageBus_SAS:        return QApplication::translate("VBoxGlobal", "SAS", "StorageBus");
+        case KStorageBus_USB:        return QApplication::translate("VBoxGlobal", "USB", "StorageBus");
+        case KStorageBus_PCIe:       return QApplication::translate("VBoxGlobal", "PCIe", "StorageBus");
         case KStorageBus_VirtioSCSI: return QApplication::translate("VBoxGlobal", "virtio-scsi", "StorageBus");
-        default: AssertMsgFailed(("No text for %d", bus)); break;
+        default:                     AssertMsgFailed(("No text for %d", bus)); break;
     }
     return QString();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp	(revision 78520)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp	(revision 78521)
@@ -298,75 +298,75 @@
 
     /* Controller file-names: */
-    m_names.insert(ControllerAddEn,          ":/controller_add_16px.png");
-    m_names.insert(ControllerAddDis,         ":/controller_add_disabled_16px.png");
-    m_names.insert(ControllerDelEn,          ":/controller_remove_16px.png");
-    m_names.insert(ControllerDelDis,         ":/controller_remove_disabled_16px.png");
+    m_names.insert(ControllerAddEn,              ":/controller_add_16px.png");
+    m_names.insert(ControllerAddDis,             ":/controller_add_disabled_16px.png");
+    m_names.insert(ControllerDelEn,              ":/controller_remove_16px.png");
+    m_names.insert(ControllerDelDis,             ":/controller_remove_disabled_16px.png");
     /* Attachment file-names: */
-    m_names.insert(AttachmentAddEn,          ":/attachment_add_16px.png");
-    m_names.insert(AttachmentAddDis,         ":/attachment_add_disabled_16px.png");
-    m_names.insert(AttachmentDelEn,          ":/attachment_remove_16px.png");
-    m_names.insert(AttachmentDelDis,         ":/attachment_remove_disabled_16px.png");
+    m_names.insert(AttachmentAddEn,              ":/attachment_add_16px.png");
+    m_names.insert(AttachmentAddDis,             ":/attachment_add_disabled_16px.png");
+    m_names.insert(AttachmentDelEn,              ":/attachment_remove_16px.png");
+    m_names.insert(AttachmentDelDis,             ":/attachment_remove_disabled_16px.png");
     /* Specific controller default/expand/collapse file-names: */
-    m_names.insert(IDEControllerNormal,      ":/ide_16px.png");
-    m_names.insert(IDEControllerExpand,      ":/ide_expand_16px.png");
-    m_names.insert(IDEControllerCollapse,    ":/ide_collapse_16px.png");
-    m_names.insert(SATAControllerNormal,     ":/sata_16px.png");
-    m_names.insert(SATAControllerExpand,     ":/sata_expand_16px.png");
-    m_names.insert(SATAControllerCollapse,   ":/sata_collapse_16px.png");
-    m_names.insert(SCSIControllerNormal,     ":/scsi_16px.png");
-    m_names.insert(SCSIControllerExpand,     ":/scsi_expand_16px.png");
-    m_names.insert(SCSIControllerCollapse,   ":/scsi_collapse_16px.png");
-    m_names.insert(SASControllerNormal,      ":/sata_16px.png");
-    m_names.insert(SASControllerExpand,      ":/sata_expand_16px.png");
-    m_names.insert(SASControllerCollapse,    ":/sata_collapse_16px.png");
-    m_names.insert(USBControllerNormal,      ":/usb_16px.png");
-    m_names.insert(USBControllerExpand,      ":/usb_expand_16px.png");
-    m_names.insert(USBControllerCollapse,    ":/usb_collapse_16px.png");
-    m_names.insert(NVMeControllerNormal,     ":/ide_16px.png");
-    m_names.insert(NVMeControllerExpand,     ":/ide_expand_16px.png");
-    m_names.insert(NVMeControllerCollapse,   ":/ide_collapse_16px.png");
-    m_names.insert(VirtioSCSIControllerNormal, ":/scsi_16px.png");
-    m_names.insert(VirtioSCSIControllerExpand, ":/scsi_expand_16px.png");
+    m_names.insert(IDEControllerNormal,          ":/ide_16px.png");
+    m_names.insert(IDEControllerExpand,          ":/ide_expand_16px.png");
+    m_names.insert(IDEControllerCollapse,        ":/ide_collapse_16px.png");
+    m_names.insert(SATAControllerNormal,         ":/sata_16px.png");
+    m_names.insert(SATAControllerExpand,         ":/sata_expand_16px.png");
+    m_names.insert(SATAControllerCollapse,       ":/sata_collapse_16px.png");
+    m_names.insert(SCSIControllerNormal,         ":/scsi_16px.png");
+    m_names.insert(SCSIControllerExpand,         ":/scsi_expand_16px.png");
+    m_names.insert(SCSIControllerCollapse,       ":/scsi_collapse_16px.png");
+    m_names.insert(SASControllerNormal,          ":/sata_16px.png");
+    m_names.insert(SASControllerExpand,          ":/sata_expand_16px.png");
+    m_names.insert(SASControllerCollapse,        ":/sata_collapse_16px.png");
+    m_names.insert(USBControllerNormal,          ":/usb_16px.png");
+    m_names.insert(USBControllerExpand,          ":/usb_expand_16px.png");
+    m_names.insert(USBControllerCollapse,        ":/usb_collapse_16px.png");
+    m_names.insert(NVMeControllerNormal,         ":/ide_16px.png");
+    m_names.insert(NVMeControllerExpand,         ":/ide_expand_16px.png");
+    m_names.insert(NVMeControllerCollapse,       ":/ide_collapse_16px.png");
+    m_names.insert(VirtioSCSIControllerNormal,   ":/scsi_16px.png");
+    m_names.insert(VirtioSCSIControllerExpand,   ":/scsi_expand_16px.png");
     m_names.insert(VirtioSCSIControllerCollapse, ":/scsi_collapse_16px.png");
-    m_names.insert(FloppyControllerNormal,   ":/floppy_16px.png");
-    m_names.insert(FloppyControllerExpand,   ":/floppy_expand_16px.png");
-    m_names.insert(FloppyControllerCollapse, ":/floppy_collapse_16px.png");
+    m_names.insert(FloppyControllerNormal,       ":/floppy_16px.png");
+    m_names.insert(FloppyControllerExpand,       ":/floppy_expand_16px.png");
+    m_names.insert(FloppyControllerCollapse,     ":/floppy_collapse_16px.png");
     /* Specific controller add file-names: */
-    m_names.insert(IDEControllerAddEn,       ":/ide_add_16px.png");
-    m_names.insert(IDEControllerAddDis,      ":/ide_add_disabled_16px.png");
-    m_names.insert(SATAControllerAddEn,      ":/sata_add_16px.png");
-    m_names.insert(SATAControllerAddDis,     ":/sata_add_disabled_16px.png");
-    m_names.insert(SCSIControllerAddEn,      ":/scsi_add_16px.png");
-    m_names.insert(SCSIControllerAddDis,     ":/scsi_add_disabled_16px.png");
-    m_names.insert(SASControllerAddEn,       ":/sata_add_16px.png");
-    m_names.insert(SASControllerAddDis,      ":/sata_add_disabled_16px.png");
-    m_names.insert(USBControllerAddEn,       ":/usb_add_16px.png");
-    m_names.insert(USBControllerAddDis,      ":/usb_add_disabled_16px.png");
-    m_names.insert(NVMeControllerAddEn,      ":/ide_add_16px.png");
-    m_names.insert(NVMeControllerAddDis,     ":/ide_add_disabled_16px.png");
-    m_names.insert(VirtioSCSIControllerAddEn, ":/scsi_add_16px.png");
-    m_names.insert(VirtioSCSIControllerAddDis, ":/scsi_add_disabled_16px.png");
-    m_names.insert(FloppyControllerAddEn,    ":/floppy_add_16px.png");
-    m_names.insert(FloppyControllerAddDis,   ":/floppy_add_disabled_16px.png");
+    m_names.insert(IDEControllerAddEn,           ":/ide_add_16px.png");
+    m_names.insert(IDEControllerAddDis,          ":/ide_add_disabled_16px.png");
+    m_names.insert(SATAControllerAddEn,          ":/sata_add_16px.png");
+    m_names.insert(SATAControllerAddDis,         ":/sata_add_disabled_16px.png");
+    m_names.insert(SCSIControllerAddEn,          ":/scsi_add_16px.png");
+    m_names.insert(SCSIControllerAddDis,         ":/scsi_add_disabled_16px.png");
+    m_names.insert(SASControllerAddEn,           ":/sata_add_16px.png");
+    m_names.insert(SASControllerAddDis,          ":/sata_add_disabled_16px.png");
+    m_names.insert(USBControllerAddEn,           ":/usb_add_16px.png");
+    m_names.insert(USBControllerAddDis,          ":/usb_add_disabled_16px.png");
+    m_names.insert(NVMeControllerAddEn,          ":/ide_add_16px.png");
+    m_names.insert(NVMeControllerAddDis,         ":/ide_add_disabled_16px.png");
+    m_names.insert(VirtioSCSIControllerAddEn,    ":/scsi_add_16px.png");
+    m_names.insert(VirtioSCSIControllerAddDis,   ":/scsi_add_disabled_16px.png");
+    m_names.insert(FloppyControllerAddEn,        ":/floppy_add_16px.png");
+    m_names.insert(FloppyControllerAddDis,       ":/floppy_add_disabled_16px.png");
     /* Specific attachment file-names: */
-    m_names.insert(HDAttachmentNormal,       ":/hd_16px.png");
-    m_names.insert(CDAttachmentNormal,       ":/cd_16px.png");
-    m_names.insert(FDAttachmentNormal,       ":/fd_16px.png");
+    m_names.insert(HDAttachmentNormal,           ":/hd_16px.png");
+    m_names.insert(CDAttachmentNormal,           ":/cd_16px.png");
+    m_names.insert(FDAttachmentNormal,           ":/fd_16px.png");
     /* Specific attachment add file-names: */
-    m_names.insert(HDAttachmentAddEn,        ":/hd_add_16px.png");
-    m_names.insert(HDAttachmentAddDis,       ":/hd_add_disabled_16px.png");
-    m_names.insert(CDAttachmentAddEn,        ":/cd_add_16px.png");
-    m_names.insert(CDAttachmentAddDis,       ":/cd_add_disabled_16px.png");
-    m_names.insert(FDAttachmentAddEn,        ":/fd_add_16px.png");
-    m_names.insert(FDAttachmentAddDis,       ":/fd_add_disabled_16px.png");
+    m_names.insert(HDAttachmentAddEn,            ":/hd_add_16px.png");
+    m_names.insert(HDAttachmentAddDis,           ":/hd_add_disabled_16px.png");
+    m_names.insert(CDAttachmentAddEn,            ":/cd_add_16px.png");
+    m_names.insert(CDAttachmentAddDis,           ":/cd_add_disabled_16px.png");
+    m_names.insert(FDAttachmentAddEn,            ":/fd_add_16px.png");
+    m_names.insert(FDAttachmentAddDis,           ":/fd_add_disabled_16px.png");
     /* Specific attachment custom file-names: */
-    m_names.insert(ChooseExistingEn,         ":/select_file_16px.png");
-    m_names.insert(ChooseExistingDis,        ":/select_file_disabled_16px.png");
-    m_names.insert(HDNewEn,                  ":/hd_new_16px.png");
-    m_names.insert(HDNewDis,                 ":/hd_new_disabled_16px.png");
-    m_names.insert(CDUnmountEnabled,         ":/cd_unmount_16px.png");
-    m_names.insert(CDUnmountDisabled,        ":/cd_unmount_disabled_16px.png");
-    m_names.insert(FDUnmountEnabled,         ":/fd_unmount_16px.png");
-    m_names.insert(FDUnmountDisabled,        ":/fd_unmount_disabled_16px.png");
+    m_names.insert(ChooseExistingEn,             ":/select_file_16px.png");
+    m_names.insert(ChooseExistingDis,            ":/select_file_disabled_16px.png");
+    m_names.insert(HDNewEn,                      ":/hd_new_16px.png");
+    m_names.insert(HDNewDis,                     ":/hd_new_disabled_16px.png");
+    m_names.insert(CDUnmountEnabled,             ":/cd_unmount_16px.png");
+    m_names.insert(CDUnmountDisabled,            ":/cd_unmount_disabled_16px.png");
+    m_names.insert(FDUnmountEnabled,             ":/fd_unmount_16px.png");
+    m_names.insert(FDUnmountDisabled,            ":/fd_unmount_disabled_16px.png");
 }
 